// ------ Libraries and Definitions ------
#include "simpletools.h"
#include "ws2812.h"

#define LED_PIN 12
#define LED_COUNT 8

#include "oledc.h"
#include "colormath.h"

// ------ Global Variables and Objects ------
ws2812 * __ws2812b;
int RGBleds[8];

// ------ Function Declarations ------
int constrain(int __cVal, int __cMin, int __cMax);

// ------ Main Program ------
int main()
{
  __ws2812b = ws2812b_open();

  oledc_init(0, 1, 2, 3, 4, 2);
  for (int __ldx = 2; __ldx <= 8; __ldx++)
  {
    RGBleds[constrain(__ldx, 1, LED_COUNT) - 1] = 0x000000;
  }
  if (1 > 0 && 1 <= LED_COUNT)
  {
    RGBleds[1 - 1] = 0xff0000;
  }
  ws2812_set(__ws2812b, LED_PIN, RGBleds, LED_COUNT);
  pause(1000);
  if (1 > 0 && 1 <= LED_COUNT)
  {
    RGBleds[1 - 1] = 0x3333ff;
  }
  ws2812_set(__ws2812b, LED_PIN, RGBleds, LED_COUNT);
  pause(1000);
  if (1 > 0 && 1 <= LED_COUNT)
  {
    RGBleds[1 - 1] = 0xffff00;
  }
  ws2812_set(__ws2812b, LED_PIN, RGBleds, LED_COUNT);
  pause(1000);
  if (1 > 0 && 1 <= LED_COUNT)
  {
    RGBleds[1 - 1] = 0x009900;
  }
  ws2812_set(__ws2812b, LED_PIN, RGBleds, LED_COUNT);
  pause(1000);
  if (1 > 0 && 1 <= LED_COUNT)
  {
    RGBleds[1 - 1] = 0x000000;
  }
  ws2812_set(__ws2812b, LED_PIN, RGBleds, LED_COUNT);
  oledc_setTextSize(SMALL);
  oledc_setTextFont(FONT_SANS);
  oledc_fillRect(0, 0, 95, 63, oledc_color565(get8bitColor(0x3333ff, "RED"), get8bitColor(0x3333ff, "GREEN"), get8bitColor(0x3333ff, "BLUE")));
  oledc_setCursor(2, 2, 0);
  oledc_drawText("Hello");
  oledc_setCursor(2, 12, 0);
  oledc_drawText("World");
}

// ------ Functions ------
int constrain(int __cVal, int __cMin, int __cMax)
{
  if (__cVal < __cMin) __cVal = __cMin;
  if (__cVal > __cMax) __cVal = __cMax;
  return __cVal;
}